<html>
<head>
<title>OGRE: OgreTexture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreTexture.h</h1><a href="OgreTexture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _Texture_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _Texture_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreHardwareBuffer_8h.html">OgreHardwareBuffer.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreResource_8h.html">OgreResource.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreImage_8h.html">OgreImage.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00041"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67">00041</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67" title="Enum identifying the texture usage.">TextureUsage</a>
<a name="l00042"></a>00042     {
<a name="l00044"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67375858a86cadfb2a4d20fe837fdb85b3">00044</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67375858a86cadfb2a4d20fe837fdb85b3">TU_STATIC</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466306f26f67ab31d60248314c9c6c77c9edb" title="Static buffer which the application rarely modifies once created.">HardwareBuffer::HBU_STATIC</a>,
<a name="l00045"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67d18031f12c4bd22f73b09a4536e99df5">00045</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67d18031f12c4bd22f73b09a4536e99df5">TU_DYNAMIC</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630bec61c14b13652a06566a79afd6f7518" title="Indicates the application would like to modify this buffer with the CPU fairly often...">HardwareBuffer::HBU_DYNAMIC</a>,
<a name="l00046"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67f7b0d53154ffc7c389404dc51c792655">00046</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67f7b0d53154ffc7c389404dc51c792655">TU_WRITE_ONLY</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466302fe20ff00e9acb928a2d9680f0c505e2" title="Indicates the application will never read the contents of the buffer back, it will...">HardwareBuffer::HBU_WRITE_ONLY</a>,
<a name="l00047"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf672b9d0399c32f2098957ebc089c337e55">00047</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf672b9d0399c32f2098957ebc089c337e55">TU_STATIC_WRITE_ONLY</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466305ffbb339becd31435c5f616be4c28996" title="Combination of HBU_STATIC and HBU_WRITE_ONLY.">HardwareBuffer::HBU_STATIC_WRITE_ONLY</a>, 
<a name="l00048"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67c26eda030d21e0491461edea89394493">00048</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67c26eda030d21e0491461edea89394493">TU_DYNAMIC_WRITE_ONLY</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630a0c82d1b27d6cc04e4b5f6d47a22a74c" title="Combination of HBU_DYNAMIC and HBU_WRITE_ONLY.">HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY</a>,
<a name="l00049"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf6779920182637c94fabcf834950096483f">00049</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf6779920182637c94fabcf834950096483f">TU_DYNAMIC_WRITE_ONLY_DISCARDABLE</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec4663029ff2e0fd2b408359e84291b27282516" title="Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.">HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE</a>,
<a name="l00051"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf677c14cc95a59af42a63eb33fc9de05d27">00051</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf677c14cc95a59af42a63eb33fc9de05d27" title="mipmaps will be automatically generated for this texture">TU_AUTOMIPMAP</a> = 0x100,
<a name="l00054"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67e1661d9846a9b4e83c2e4cd99fc6ad9d">00054</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67e1661d9846a9b4e83c2e4cd99fc6ad9d" title="this texture will be a render target, ie.">TU_RENDERTARGET</a> = 0x200,
<a name="l00056"></a><a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67caa45fe77d1becf4c5bd353bc2aa764b">00056</a>         <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf67caa45fe77d1becf4c5bd353bc2aa764b" title="default to automatic mipmap generation static textures">TU_DEFAULT</a> = <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf677c14cc95a59af42a63eb33fc9de05d27" title="mipmaps will be automatically generated for this texture">TU_AUTOMIPMAP</a> | <a class="code" href="namespaceOgre.html#f140ec886884a864abc74a7556f8bf672b9d0399c32f2098957ebc089c337e55">TU_STATIC_WRITE_ONLY</a>
<a name="l00057"></a>00057         
<a name="l00058"></a>00058     };
<a name="l00059"></a>00059 
<a name="l00062"></a><a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7">00062</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a>
<a name="l00063"></a>00063     {
<a name="l00065"></a><a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d718bf88d3a14ba28d6602689e398416bd">00065</a>         <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d718bf88d3a14ba28d6602689e398416bd" title="1D texture, used in combination with 1D texture coordinates">TEX_TYPE_1D</a> = 1,
<a name="l00067"></a><a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7f1f732018f5a2a7d35233e2ceeb4ee0e">00067</a>         <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7f1f732018f5a2a7d35233e2ceeb4ee0e" title="2D texture, used in combination with 2D texture coordinates (default)">TEX_TYPE_2D</a> = 2,
<a name="l00069"></a><a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7a80e2545e817591a0b4547f987987d43">00069</a>         <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7a80e2545e817591a0b4547f987987d43" title="3D volume texture, used in combination with 3D texture coordinates">TEX_TYPE_3D</a> = 3,
<a name="l00071"></a><a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7e295fe0fa26623b66cc023f462962344">00071</a>         <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7e295fe0fa26623b66cc023f462962344" title="3D cube map, used in combination with 3D texture coordinates">TEX_TYPE_CUBE_MAP</a> = 4
<a name="l00072"></a>00072     };
<a name="l00073"></a>00073 
<a name="l00076"></a><a class="code" href="namespaceOgre.html#528ce4f4c67c9b043e1f0b8bb3cdf255">00076</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#528ce4f4c67c9b043e1f0b8bb3cdf255" title="Enum identifying special mipmap numbers.">TextureMipmap</a>
<a name="l00077"></a>00077     {
<a name="l00079"></a><a class="code" href="namespaceOgre.html#528ce4f4c67c9b043e1f0b8bb3cdf2555a6b498127bf3fa219dadfdaaa50b9dd">00079</a>         <a class="code" href="namespaceOgre.html#528ce4f4c67c9b043e1f0b8bb3cdf2555a6b498127bf3fa219dadfdaaa50b9dd" title="Generate mipmaps up to 1x1.">MIP_UNLIMITED</a> = 0x7FFFFFFF,
<a name="l00081"></a><a class="code" href="namespaceOgre.html#528ce4f4c67c9b043e1f0b8bb3cdf25556eea45719de5246f4ea9b8e8b54921d">00081</a>         <a class="code" href="namespaceOgre.html#528ce4f4c67c9b043e1f0b8bb3cdf25556eea45719de5246f4ea9b8e8b54921d" title="Use TextureManager default.">MIP_DEFAULT</a> = -1
<a name="l00082"></a>00082     };
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     <span class="comment">// Forward declaration</span>
<a name="l00085"></a>00085     <span class="keyword">class </span>TexturePtr;
<a name="l00086"></a>00086 
<a name="l00096"></a><a class="code" href="classOgre_1_1Texture.html">00096</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098     <span class="keyword">public</span>:
<a name="l00099"></a>00099         <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle,
<a name="l00100"></a>00100             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00101"></a>00101 
<a name="l00104"></a><a class="code" href="classOgre_1_1Texture.html#99ab7ce9aba371bab2f04fe1eebe6f26">00104</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTextureType(<a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> ttype ) { mTextureType = ttype; }
<a name="l00105"></a>00105 
<a name="l00108"></a><a class="code" href="classOgre_1_1Texture.html#3db3e97f86e298f79fd09e511f572cc1">00108</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> getTextureType(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTextureType; }
<a name="l00109"></a>00109 
<a name="l00112"></a><a class="code" href="classOgre_1_1Texture.html#73913a082bfc8f1e3de44441df92308a">00112</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getNumMipmaps(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{<span class="keywordflow">return</span> mNumMipmaps;}
<a name="l00113"></a>00113 
<a name="l00118"></a><a class="code" href="classOgre_1_1Texture.html#3cd584d5e1b9bbd1eb665303f9fca7ee">00118</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setNumMipmaps(<span class="keywordtype">size_t</span> num) {mNumRequestedMipmaps = mNumMipmaps = num;}
<a name="l00119"></a>00119 
<a name="l00124"></a><a class="code" href="classOgre_1_1Texture.html#3435f815f90fdf90e3c28393125e3168">00124</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getMipmapsHardwareGenerated(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMipmapsHardwareGenerated; }
<a name="l00125"></a>00125 
<a name="l00128"></a><a class="code" href="classOgre_1_1Texture.html#ae8fa69ad2ea0d4b84c85d280197953b">00128</a>         <span class="keyword">virtual</span> <span class="keywordtype">float</span> getGamma(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGamma; }
<a name="l00129"></a>00129 
<a name="l00134"></a><a class="code" href="classOgre_1_1Texture.html#34a2cf25885b2d6f16adc1dbd7275e09">00134</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setGamma(<span class="keywordtype">float</span> g) { mGamma = g; }
<a name="l00135"></a>00135 
<a name="l00138"></a><a class="code" href="classOgre_1_1Texture.html#487fd460a132f1c4097ec1f6d2e7c37c">00138</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getHeight(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHeight; }
<a name="l00139"></a>00139 
<a name="l00142"></a><a class="code" href="classOgre_1_1Texture.html#68051f56bb8d87ce19640a8026586207">00142</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getWidth(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWidth; }
<a name="l00143"></a>00143 
<a name="l00146"></a><a class="code" href="classOgre_1_1Texture.html#08698c8524b74c8303927f665f36e827">00146</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getDepth(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDepth; }
<a name="l00147"></a>00147 
<a name="l00150"></a><a class="code" href="classOgre_1_1Texture.html#772f4bd16b6b629f16f112926be4d460">00150</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getSrcHeight(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcHeight; }
<a name="l00151"></a>00151 
<a name="l00154"></a><a class="code" href="classOgre_1_1Texture.html#8637d1b6b0c6b17c10dbe0bc65ce8dc4">00154</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getSrcWidth(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcWidth; }
<a name="l00155"></a>00155 
<a name="l00158"></a><a class="code" href="classOgre_1_1Texture.html#9037f86414b57597677ea98d66c40001">00158</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getSrcDepth(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcDepth; }
<a name="l00159"></a>00159 
<a name="l00162"></a><a class="code" href="classOgre_1_1Texture.html#b4f95c16ba72153a00a3422289099296">00162</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setHeight(<span class="keywordtype">size_t</span> h) { mHeight = mSrcHeight = h; }
<a name="l00163"></a>00163 
<a name="l00166"></a><a class="code" href="classOgre_1_1Texture.html#b966147d746a969aa80a0ae71d6fb0e2">00166</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setWidth(<span class="keywordtype">size_t</span> w) { mWidth = mSrcWidth = w; }
<a name="l00167"></a>00167 
<a name="l00171"></a><a class="code" href="classOgre_1_1Texture.html#fd7eb62399bd48b21f6763eba94ab28d">00171</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDepth(<span class="keywordtype">size_t</span> d)  { mDepth = mSrcDepth = d; }
<a name="l00172"></a>00172 
<a name="l00175"></a><a class="code" href="classOgre_1_1Texture.html#5544f33879e292ff3d0c6fb13129ba0d">00175</a>         <span class="keyword">virtual</span> <span class="keywordtype">int</span> getUsage()<span class="keyword"> const</span>
<a name="l00176"></a>00176 <span class="keyword">        </span>{
<a name="l00177"></a>00177             <span class="keywordflow">return</span> mUsage;
<a name="l00178"></a>00178         }
<a name="l00179"></a>00179 
<a name="l00187"></a><a class="code" href="classOgre_1_1Texture.html#04969ca1d25bf40e71e907f2cdb7443b">00187</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setUsage(<span class="keywordtype">int</span> u) { mUsage = u; }
<a name="l00188"></a>00188 
<a name="l00200"></a>00200         <span class="keyword">virtual</span> <span class="keywordtype">void</span> createInternalResources(<span class="keywordtype">void</span>);
<a name="l00201"></a>00201 
<a name="l00204"></a>00204         <span class="keyword">virtual</span> <span class="keywordtype">void</span> freeInternalResources(<span class="keywordtype">void</span>);
<a name="l00205"></a>00205         
<a name="l00208"></a>00208         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyToTexture( <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; target );
<a name="l00209"></a>00209 
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadImage( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp;img );
<a name="l00217"></a>00217             
<a name="l00228"></a>00228         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadRawData( <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, 
<a name="l00229"></a>00229             <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> uWidth, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> uHeight, <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> eFormat);
<a name="l00230"></a>00230 
<a name="l00236"></a>00236         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _loadImages( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#ae7e3838a0d4d71c8b4f528e43caf9d2">ConstImagePtrList</a>&amp; images );
<a name="l00237"></a>00237 
<a name="l00239"></a><a class="code" href="classOgre_1_1Texture.html#91a5ec6b7cae49a1f7aa05b7beac966b">00239</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getFormat()<span class="keyword"> const</span>
<a name="l00240"></a>00240 <span class="keyword">        </span>{
<a name="l00241"></a>00241             <span class="keywordflow">return</span> mFormat;
<a name="l00242"></a>00242         }
<a name="l00243"></a>00243 
<a name="l00245"></a><a class="code" href="classOgre_1_1Texture.html#01e66834e5af4ac5d24222d24c09a9ca">00245</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getDesiredFormat(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00246"></a>00246 <span class="keyword">        </span>{
<a name="l00247"></a>00247             <span class="keywordflow">return</span> mDesiredFormat;
<a name="l00248"></a>00248         }
<a name="l00249"></a>00249 
<a name="l00253"></a><a class="code" href="classOgre_1_1Texture.html#d4dccbd257ef80d031b4d9e72ca08164">00253</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getSrcFormat(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00254"></a>00254 <span class="keyword">        </span>{
<a name="l00255"></a>00255             <span class="keywordflow">return</span> mSrcFormat;
<a name="l00256"></a>00256         }
<a name="l00257"></a>00257 
<a name="l00259"></a>00259         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFormat(<a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> pf);
<a name="l00260"></a>00260 
<a name="l00262"></a>00262         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasAlpha(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00263"></a>00263 
<a name="l00269"></a>00269         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDesiredIntegerBitDepth(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> bits);
<a name="l00270"></a>00270 
<a name="l00273"></a>00273         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getDesiredIntegerBitDepth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00274"></a>00274 
<a name="l00280"></a>00280         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDesiredFloatBitDepth(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> bits);
<a name="l00281"></a>00281 
<a name="l00284"></a>00284         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getDesiredFloatBitDepth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00285"></a>00285 
<a name="l00288"></a>00288         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDesiredBitDepths(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> integerBits, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> floatBits);
<a name="l00289"></a>00289 
<a name="l00292"></a>00292         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTreatLuminanceAsAlpha(<span class="keywordtype">bool</span> asAlpha);
<a name="l00293"></a>00293 
<a name="l00296"></a>00296         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getTreatLuminanceAsAlpha(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00297"></a>00297 
<a name="l00301"></a>00301         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getNumFaces() <span class="keyword">const</span>;
<a name="l00302"></a>00302 
<a name="l00315"></a>00315         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> getBuffer(<span class="keywordtype">size_t</span> face=0, <span class="keywordtype">size_t</span> mipmap=0) = 0;
<a name="l00316"></a>00316 
<a name="l00317"></a>00317     <span class="keyword">protected</span>:
<a name="l00318"></a><a class="code" href="classOgre_1_1Texture.html#05ffc612f2d228396455f429325d99d4">00318</a>         <span class="keywordtype">size_t</span> mHeight;
<a name="l00319"></a><a class="code" href="classOgre_1_1Texture.html#1619297beb23828218b26ce18362a984">00319</a>         <span class="keywordtype">size_t</span> mWidth;
<a name="l00320"></a><a class="code" href="classOgre_1_1Texture.html#55f60f21398b55836e13a692b90dd736">00320</a>         <span class="keywordtype">size_t</span> mDepth;
<a name="l00321"></a>00321 
<a name="l00322"></a><a class="code" href="classOgre_1_1Texture.html#6958c92e9f0e66c4a3d132ed273ea319">00322</a>         <span class="keywordtype">size_t</span> mNumRequestedMipmaps;
<a name="l00323"></a><a class="code" href="classOgre_1_1Texture.html#6b82c3ed419e91a11bd9d0063df83ed9">00323</a>         <span class="keywordtype">size_t</span> mNumMipmaps;
<a name="l00324"></a><a class="code" href="classOgre_1_1Texture.html#78c173eadbdbce6c766632a40fc0363c">00324</a>         <span class="keywordtype">bool</span> mMipmapsHardwareGenerated;
<a name="l00325"></a><a class="code" href="classOgre_1_1Texture.html#91414bf8610084680cc21144c93e34ca">00325</a>         <span class="keywordtype">float</span> mGamma;
<a name="l00326"></a>00326 
<a name="l00327"></a><a class="code" href="classOgre_1_1Texture.html#ab3add1d83300d2518d4ae9864c32651">00327</a>         <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> mTextureType;
<a name="l00328"></a><a class="code" href="classOgre_1_1Texture.html#74872f190e8c6d2da750c03698ad73fd">00328</a>         <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> mFormat;
<a name="l00329"></a><a class="code" href="classOgre_1_1Texture.html#e3c39759ac6bea7faa7c60d3994927a4">00329</a>         <span class="keywordtype">int</span> mUsage; <span class="comment">// Bit field, so this can't be TextureUsage</span>
<a name="l00330"></a>00330 
<a name="l00331"></a><a class="code" href="classOgre_1_1Texture.html#2598c4e24ba37ce5f82393be82aeddc6">00331</a>         <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> mSrcFormat;
<a name="l00332"></a><a class="code" href="classOgre_1_1Texture.html#a15877330d8c2ce5b6cf6715937f2b12">00332</a>         <span class="keywordtype">size_t</span> mSrcWidth, mSrcHeight, mSrcDepth;
<a name="l00333"></a>00333 
<a name="l00334"></a><a class="code" href="classOgre_1_1Texture.html#4c9e046e633bacb741cbe2518dfbc649">00334</a>         <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> mDesiredFormat;
<a name="l00335"></a><a class="code" href="classOgre_1_1Texture.html#1797d9ab733702d0c0b05ba3fd6f1584">00335</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mDesiredIntegerBitDepth;
<a name="l00336"></a><a class="code" href="classOgre_1_1Texture.html#a06a0be1885e8ff96fde33277140e46f">00336</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mDesiredFloatBitDepth;
<a name="l00337"></a><a class="code" href="classOgre_1_1Texture.html#a922f905790cc650b2761caa2e28e51e">00337</a>         <span class="keywordtype">bool</span> mTreatLuminanceAsAlpha;
<a name="l00338"></a>00338 
<a name="l00339"></a><a class="code" href="classOgre_1_1Texture.html#e5bc056fc6cc83ae12cf2a3d0786e87b">00339</a>         <span class="keywordtype">bool</span> mInternalResourcesCreated;
<a name="l00340"></a>00340 
<a name="l00342"></a>00342         <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00343"></a>00343         
<a name="l00344"></a>00344 
<a name="l00347"></a>00347         <span class="keyword">virtual</span> <span class="keywordtype">void</span> createInternalResourcesImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00348"></a>00348 
<a name="l00351"></a>00351         <span class="keyword">virtual</span> <span class="keywordtype">void</span> freeInternalResourcesImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00352"></a>00352 
<a name="l00354"></a>00354         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00355"></a>00355 
<a name="l00356"></a>00356     };
<a name="l00357"></a>00357 
<a name="l00364"></a><a class="code" href="classOgre_1_1TexturePtr.html">00364</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;Texture&gt; 
<a name="l00365"></a>00365     {
<a name="l00366"></a>00366     <span class="keyword">public</span>:
<a name="l00367"></a><a class="code" href="classOgre_1_1TexturePtr.html#13754a294a53828f0e5a4c39900a96c0">00367</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;() {}
<a name="l00368"></a><a class="code" href="classOgre_1_1TexturePtr.html#4b1f2286b5b01581283f39a6c5e3ddea">00368</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>(<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;(rep) {}
<a name="l00369"></a><a class="code" href="classOgre_1_1TexturePtr.html#5223bb40c734e8307aea5970ea8ceedc">00369</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;(r) {} 
<a name="l00370"></a><a class="code" href="classOgre_1_1TexturePtr.html#a949c8217f4bdbd53b3071ce91dbce1f">00370</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;()
<a name="l00371"></a>00371         {
<a name="l00372"></a>00372             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00373"></a>00373             <a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00374"></a>00374             {
<a name="l00375"></a>00375                 <a class="code" href="OgrePrerequisites_8h.html#8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00376"></a>00376                 <a class="code" href="OgrePrerequisites_8h.html#cf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00377"></a>00377                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00378"></a>00378                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00379"></a>00379                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00380"></a>00380                 {
<a name="l00381"></a>00381                     ++(*pUseCount);
<a name="l00382"></a>00382                 }
<a name="l00383"></a>00383             }
<a name="l00384"></a>00384         }
<a name="l00385"></a>00385 
<a name="l00387"></a><a class="code" href="classOgre_1_1TexturePtr.html#9c0d31e0de80559b9ba2749f96caff65">00387</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; r)
<a name="l00388"></a>00388         {
<a name="l00389"></a>00389             <span class="keywordflow">if</span> (pRep == static_cast&lt;Texture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00390"></a>00390                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00391"></a>00391             release();
<a name="l00392"></a>00392             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00393"></a>00393             <a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00394"></a>00394             {
<a name="l00395"></a>00395                 <a class="code" href="OgrePrerequisites_8h.html#8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00396"></a>00396                 <a class="code" href="OgrePrerequisites_8h.html#cf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00397"></a>00397                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00398"></a>00398                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00399"></a>00399                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00400"></a>00400                 {
<a name="l00401"></a>00401                     ++(*pUseCount);
<a name="l00402"></a>00402                 }
<a name="l00403"></a>00403             }
<a name="l00404"></a>00404             <span class="keywordflow">else</span>
<a name="l00405"></a>00405             {
<a name="l00406"></a>00406                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00407"></a>00407                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">"RHS must be null if it has no mutex!"</span>);
<a name="l00408"></a>00408                 setNull();
<a name="l00409"></a>00409             }
<a name="l00410"></a>00410             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00411"></a>00411         }
<a name="l00412"></a>00412     };
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 }
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
